// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/driver/intime/os_read.c $
// $Rev: 43205 $
// $Date: 2018-07-08 17:01:59 -0500 (Sun, 08 Jul 2018) $

// INtime: Device Driver: source file

#include "main.h"



//*****************************************************************************
// Return:
//	0	Success, no data transferred
//	< 0	Failure: value is -errno or -GetLastRtError()
//	> 0	number of bytes transferred
long os_read(GSC_ALT_STRUCT_T* alt, void* buf, size_t count)
{
#if defined(DEV_SUPPORTS_READ)

	long	ret;

	if (alt)
	{
		alt->rx.non_blocking	= 0;
		ret	= gsc_read(alt, buf, count);
	}
	else
	{
		// The referenced device doesn't exist.
		ret	= -ENODEV;
		db_printf("%s: Internal failure: %s, %d\n", DEV_NAME, __FILE__, __LINE__);
	}

	return(ret);
#else
    return (-EPERM);
#endif
}


