// $URL: http://subversion:8080/svn/gsc/trunk/drivers/INtime/16AO4MF/16AO4MF_INtime_3.x_DN/samples/exit/main.c $
// $Rev: 43309 $
// $Date: 2018-07-09 22:36:37 -0500 (Mon, 09 Jul 2018) $

// INtime 4 application

#include "main.h"



// #define ********************************************************************

#define	DEV_NAME		AO4MF_BASE_NAME



//*****************************************************************************
void os_root_mbox_send_exit_msg(void)
{
	RTHANDLE	mbox;
	os_msg_t	msg;
	RTHANDLE	root;

	printf("Sending EXIT message ... ");

	root			= GetRtThreadHandles(ROOT_PROCESS);
	mbox			= LookupRtHandle(root, DEV_NAME, NO_WAIT);
	memset(&msg, 0, sizeof(msg));
	msg.msg_type	= OS_MSG_TYPE_EXIT;
	msg.size		= OS_MSG_SIZE_EXIT;
	SendRtData(mbox, &msg, msg.size);

	printf("Done\n");
}



//*****************************************************************************
static void _uncatalog_mailboxes(void)
{
	int			i;
	int			limit	= 50;
	RTHANDLE	mbox;
	char		name[64];
	RTHANDLE	root;

	printf("Uncataloging mail boxes ... ");

	root	= GetRtThreadHandles(ROOT_PROCESS);

	for (i = -1; i < limit; i++)
	{
		if (i >= 0)
			sprintf(name, "%s.%d", DEV_NAME, i);
		else
			strcpy(name, DEV_NAME);

		mbox	= LookupRtHandle(root, name, NO_WAIT);

		if (mbox == BAD_RTHANDLE)
			continue;

		UncatalogRtHandle(root, name);
	}

	printf("Done\n");
}



//*****************************************************************************
void main(void)
{
	printf("Initiating 16AO4MF driver exit.\n");
	os_root_mbox_send_exit_msg();
	_uncatalog_mailboxes();
	printf("Finished\n");
}


