// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO4MF/16AO4MF_Linux_2.x.x.x_GSC_DN/utils/open.c $
// $Rev: 42835 $
// $Date: 2018-05-17 17:29:30 -0500 (Thu, 17 May 2018) $

// 16AO4MF: Utilities: source file

#include "main.h"



/*****************************************************************************
*
*	Function:	ao4mf_open_util
*
*	Purpose:
*
*		Implement a visual wrapper around the device open call.
*
*	Arguments:
*
*		device	The zero based index of the device to access.
*
*		share	Open the device in shared access mode?
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		fd		The file descriptor is returned here.
*
*	Returned:
*
*		0		All went well. The fd value is valid.
*		> 0		The number of errors seen. The fd value is -1.
*
*****************************************************************************/

int ao4mf_open_util(int device, int share, int index, int verbose, int* fd)
{
	int	board	= device / 4;
	int	chan	= device % 4;
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Open", index);

	ret		= ao4mf_open(device, share, fd);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf(	"%s   (%s, board %d, channel %d)\n",
				errs ? "FAIL <---" : "PASS",
				share ? "Shared" : "Exclusive",
				board,
				chan);
	}

	return(errs);
}


