// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO4MF/16AO4MF_Linux_2.x.x.x_GSC_DN/utils/util_dio_tx.c $
// $Rev: 43274 $
// $Date: 2018-07-09 17:36:40 -0500 (Mon, 09 Jul 2018) $

// 16AO4MF: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ao4mf_dio_tx
*
*	Purpose:
*
*		Provide a visual wrapper for the AO4MF_IOCTL_DIO_TX service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ao4mf_dio_tx(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Digital I/O Write", index);

	ret		= ao4mf_ioctl(fd, AO4MF_IOCTL_DIO_TX, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf("%s", errs ? "FAIL <---" : "PASS");

		if ((set >= 0x00) && (set <= 0xFF))
			printf("  (0x%02lX)\n", (long) set);
		else if (set == -1)
			printf("  (Digital I/O Not Supported)\n");
		else
			printf("  (Invalid Value Returned: %ld)\n", (long) set);
	}

	if (get)
		get[0]	= set;

	return(errs);
}


