// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO4MF/16AO4MF_Linux_2.x.x.x_GSC_DN/utils/write.c $
// $Rev: 42835 $
// $Date: 2018-05-17 17:29:30 -0500 (Thu, 17 May 2018) $

// 16AO4MF: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ao4mf_write_util
*
*	Purpose:
*
*		Implement a visual wrapper around the device write call.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the board to access. Ignore if < 0.
*
*		verbose	0: errors only, !0: all output
*
*		src		The source for the data to write.
*
*		size	The voume of data to write.
*
*	Returned:
*
*		>= 0	The volume of data written.
*		< 0		The negative of the number of errors seen.
*
******************************************************************************/

int ao4mf_write_util(int fd, int index, int verbose, const void* src, size_t size)
{
	int	ret;

	if (verbose)
		gsc_label_index("Writing", index);

	ret	= ao4mf_write(fd, src, size);

	if (verbose == 0)
	{
	}
	else if (ret >= 0)
	{
		printf("PASS  (%d size)\n", ret);
	}
	else
	{
		printf("FAIL <---\n");
	}

	return(ret);
}


